GNU bug report logs - #40220
date command set linux epoch time failed

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: coreutils; Reported by: shy <mail_hysong@HIDDEN>; Keywords: notabug; Done: Bob Proulx <bob@HIDDEN>; Maintainer for coreutils is bug-coreutils@HIDDEN.

Message received at 40220 <at> debbugs.gnu.org:


Received: (at 40220) by debbugs.gnu.org; 30 Mar 2020 02:35:31 +0000
From bob@HIDDEN Sat Mar 28 12:12:24 2020
Received: from havoc.proulx.com ([96.88.95.61]:46286)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bob@HIDDEN>) id 1jIE4N-0000zq-OI
 for 40220 <at> debbugs.gnu.org; Sat, 28 Mar 2020 12:12:24 -0400
Received: from joseki.proulx.com (localhost [127.0.0.1])
 by havoc.proulx.com (Postfix) with ESMTP id 633BC2AC;
 Sat, 28 Mar 2020 10:12:17 -0600 (MDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=proulx.com;
 s=dkim2048; t=1585411937;
 bh=Jv7B2z1J8l4f58s/q/mOWqc0Nh0y1PnvT3+sX8NM3og=;
 h=Date:From:To:Cc:Subject:References:In-Reply-To:From;
 b=avnJMWmR7PW+EBwzvWZWSpK79nIahgqN1lnv21LADFVjC+fSyl2sT56fKyuZ8EcDv
 FAOJvECXAKDt/0xDTz4IGSXaWGyoTRRmXjgVGBKsx4hiEw1WXUDPURXVCG0LeIHjh4
 uZaZaPWfsAaLzLYTuNadSByxB5ipYRnYnlapcy0xuerzQ4Fdtjnv7hZlH4bFVERi/j
 TSPgDBi9CO2U3aGSJQuHQFSW33XCbn8OGgQpXIVceZXfpM8/7u0FXRX9g7X5v/QlRj
 B7e1uE7JljeaSFAzHvrBrgT0fJwxA6FyxPgtfBxszIpbshbQKNUM6QP2yqwHta4IYL
 H2LOTsm0w8LmA==
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
 by joseki.proulx.com (Postfix) with ESMTP id 2AD3021151;
 Sat, 28 Mar 2020 10:12:17 -0600 (MDT)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
 id 09F252DC93; Sat, 28 Mar 2020 10:12:16 -0600 (MDT)
Date: Sat, 28 Mar 2020 10:12:16 -0600
From: Bob Proulx <bob@HIDDEN>
To: 40220 <at> debbugs.gnu.org
Cc: shy <mail_hysong@HIDDEN>
Subject: Re: bug#40220: date command set linux epoch time failed
Message-ID: <20200328092449777810176@HIDDEN>
References: <307be938.1da0.1710f58dac0.Coremail.mail_hysong@HIDDEN>
 <20200328003050863422063@HIDDEN>
 <a97a9411-a26c-20d4-7b0e-7472cf1ac139@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <a97a9411-a26c-20d4-7b0e-7472cf1ac139@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 40220
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
X-List-Received-Date: Sat, 28 Mar 2020 16:12:24 -0000

Paul Eggert wrote:
> Bob Proulx wrote:
> > I tested this in a victim system and if I was very quick I was able to
> > log in and set the time to :10 seconds but no earlier.
> 
> Sounds like some sort of atomic-time thing, since UTC and TAI differed by 10
> seconds when they started up in 1972. Perhaps the clock in question uses TAI
> internally?

By reading the documentation for CLOCK_MONOTONIC in clock_gettime(2):

       CLOCK_MONOTONIC
              Clock that cannot be set and represents monotonic time since--as
              described by POSIX--"some unspecified point in the past".  On
              Linux, that point corresponds to the number of seconds that the
              system has been running since it was booted.

              The CLOCK_MONOTONIC clock is not affected by discontinuous jumps
              in the system time (e.g., if the system administrator manually
              changes the clock), but is affected by the incremental
              adjustments performed by adjtime(3) and NTP.  This clock does
              not count time that the system is suspended.


It's the, "On Linux, that point corresponds to the number of seconds
that the system has been running since it was booted." part that seems
to apply here just by the reading of it.  To test this I can reboot a
VM, which boots quickly, and then as soon as I think it is available
by watching the console I can ssh into it as root from another
terminal.  And then in that other terminal logged in as root I try to
execute "date -s '1970-01-01 00:00:00 UTC'" as soon as possible.  I am
never able to do so due to EINVAL.

But if I reboot and repeat the experiment trying to set a few seconds
in time later then if I am quick I can sometimes catch "date -s
'1970-01-01 00:00:10 UTC'" and have it work.  Trying again now I was
able to be quick and get logged in and set in :07 UTC.  But then if I
wait and let seconds tick by and try setting to :10 UTC seconds again
it will fail.  This matches the model described by the documentation
that CLOCK_MONOTONIC is the system uptime and the kernel is not
allowing the clock set to be before the system uptime.

If I wait longer and try setting the date to various times then
experimentally the behavior matches that I cannot set the system time
earlier than the the system uptime.

Personally I can't see an advantage for this behavior.  Because if
someone is doing an experiment and wants to reset the clock to time
zero then I don't see an advantage of blocking that from happening.
However doing so might avoid some accidental settings of the system
clock to an unintended zero time.  Just like rm --preserve-root.  But
how often does that actually happen?  And then I would want to see a
way to do it anyway for the experiment possibilities.  Here reading
the documentation it seems to be a new hard limitation coded into the
Linux kernel that is blocking this.

Bob





Information forwarded to bug-coreutils@HIDDEN:
bug#40220; Package coreutils. Full text available.

Message received at 40220 <at> debbugs.gnu.org:


Received: (at 40220) by debbugs.gnu.org; 28 Mar 2020 08:01:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 28 04:01:00 2020
Received: from localhost ([127.0.0.1]:33625 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jI6Oq-0006w4-8a
	for submit <at> debbugs.gnu.org; Sat, 28 Mar 2020 04:01:00 -0400
Received: from zimbra.cs.ucla.edu ([131.179.128.68]:33848)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eggert@HIDDEN>) id 1jI6Oo-0006vn-NF
 for 40220 <at> debbugs.gnu.org; Sat, 28 Mar 2020 04:00:59 -0400
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 206361600CC;
 Sat, 28 Mar 2020 01:00:51 -0700 (PDT)
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10032)
 with ESMTP id 9uPgk5FVHn8i; Sat, 28 Mar 2020 01:00:50 -0700 (PDT)
Received: from localhost (localhost [127.0.0.1])
 by zimbra.cs.ucla.edu (Postfix) with ESMTP id 68F811600D0;
 Sat, 28 Mar 2020 01:00:50 -0700 (PDT)
X-Virus-Scanned: amavisd-new at zimbra.cs.ucla.edu
Received: from zimbra.cs.ucla.edu ([127.0.0.1])
 by localhost (zimbra.cs.ucla.edu [127.0.0.1]) (amavisd-new, port 10026)
 with ESMTP id 4XKZ8UOPNxjp; Sat, 28 Mar 2020 01:00:50 -0700 (PDT)
Received: from [192.168.1.9] (cpe-23-242-74-103.socal.res.rr.com
 [23.242.74.103])
 by zimbra.cs.ucla.edu (Postfix) with ESMTPSA id 368881600CC;
 Sat, 28 Mar 2020 01:00:50 -0700 (PDT)
Subject: Re: bug#40220: date command set linux epoch time failed
To: Bob Proulx <bob@HIDDEN>, shy <mail_hysong@HIDDEN>
References: <307be938.1da0.1710f58dac0.Coremail.mail_hysong@HIDDEN>
 <20200328003050863422063@HIDDEN>
From: Paul Eggert <eggert@HIDDEN>
Organization: UCLA Computer Science Department
Message-ID: <a97a9411-a26c-20d4-7b0e-7472cf1ac139@HIDDEN>
Date: Sat, 28 Mar 2020 01:00:49 -0700
User-Agent: Mozilla/5.0 (X11; Linux x86_64; rv:68.0) Gecko/20100101
 Thunderbird/68.4.1
MIME-Version: 1.0
In-Reply-To: <20200328003050863422063@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Language: en-US
Content-Transfer-Encoding: 7bit
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 40220
Cc: 40220 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

On 3/27/20 11:52 PM, Bob Proulx wrote:
> I tested this in a victim system and if I was very quick I was able to
> log in and set the time to :10 seconds but no earlier.

Sounds like some sort of atomic-time thing, since UTC and TAI differed by 10 
seconds when they started up in 1972. Perhaps the clock in question uses TAI 
internally?




Information forwarded to bug-coreutils@HIDDEN:
bug#40220; Package coreutils. Full text available.
bug closed, send any further explanations to 40220 <at> debbugs.gnu.org and shy <mail_hysong@HIDDEN> Request was from Bob Proulx <bob@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) notabug. Request was from Bob Proulx <bob@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 40220 <at> debbugs.gnu.org:


Received: (at 40220) by debbugs.gnu.org; 28 Mar 2020 06:52:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Mar 28 02:52:41 2020
Received: from localhost ([127.0.0.1]:33609 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jI5Kj-0002wX-Ei
	for submit <at> debbugs.gnu.org; Sat, 28 Mar 2020 02:52:41 -0400
Received: from havoc.proulx.com ([96.88.95.61]:51662)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bob@HIDDEN>)
 id 1jI5Kh-0002wE-OK; Sat, 28 Mar 2020 02:52:40 -0400
Received: from joseki.proulx.com (localhost [127.0.0.1])
 by havoc.proulx.com (Postfix) with ESMTP id 8A9912C0;
 Sat, 28 Mar 2020 00:52:33 -0600 (MDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=proulx.com;
 s=dkim2048; t=1585378353;
 bh=mgAPXCDr12WGadreL0n4oP3UlPX2CIsby/mUDqT/938=;
 h=Date:From:To:Cc:Subject:References:In-Reply-To:From;
 b=nxU1cGThGK7UAXtOY2n6hmoTimK4wH8NRjbO/XKf2hNVyd8UORj8fgofeD4c4tjug
 ShfE7WX0xsFONIqhh6nCNjQcaBpBrsilujA1NdVOOIYCDvp6oZBHoV9J1X0ubV79Xu
 Yf5z89cvucGidhxHA1860FCW6rC3ug7JRfOZqgTvUw6D+90ctk3Sywt2rCZFYE7b7+
 fSSZbMzObkrwJTpP7uSWM2kSWg+h/kBcyJ00663TgBHB3XrRrYB9mVftgfy9gGl7BV
 avl6nPfMKwqXMu6O0cIT8JrXPk6pPip4QR7Z91qojJmz8uB39/ddMPPDqCjDePbiE4
 guV7utEVModBg==
Received: from hysteria.proulx.com (hysteria.proulx.com [192.168.230.119])
 by joseki.proulx.com (Postfix) with ESMTP id 5727021126;
 Sat, 28 Mar 2020 00:52:33 -0600 (MDT)
Received: by hysteria.proulx.com (Postfix, from userid 1000)
 id 359952DC93; Sat, 28 Mar 2020 00:52:32 -0600 (MDT)
Date: Sat, 28 Mar 2020 00:52:32 -0600
From: Bob Proulx <bob@HIDDEN>
To: shy <mail_hysong@HIDDEN>
Subject: Re: bug#40220: date command set linux epoch time failed
Message-ID: <20200328003050863422063@HIDDEN>
References: <307be938.1da0.1710f58dac0.Coremail.mail_hysong@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <307be938.1da0.1710f58dac0.Coremail.mail_hysong@HIDDEN>
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 40220
Cc: 40220 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

tag 40220 + notabug
close 40220
thanks

shy wrote:
> I use command     date -s "1970-01-20 00:00:00" to set date, but it
>  failed.  there is error message "date: can't set date: Invalid
>  argument".
>  It's UTC time and no timezone.

This is most likely a limitation of your kernel.  I can recreate this
problem on a Linux 4.9 system for example.

  TZ=UTC strace -o /tmp/out -v date -s "1970-01-01 00:00:00"

  ...
  clock_settime(CLOCK_REALTIME, {tv_sec=0, tv_nsec=0}) = -1 EINVAL (Invalid argument)
  settimeofday({tv_sec=0, tv_usec=0}, NULL) = -1 EINVAL (Invalid argument)
  ...

And the documented possible returns of EINVAL for clock_settime().

       EINVAL The clk_id specified is not supported on this system.

       EINVAL (clock_settime()): tp.tv_sec is negative or tp.tv_nsec is
              outside the range [0..999,999,999].

       EINVAL (since Linux 4.3)
              A call to clock_settime() with a clk_id of CLOCK_REALTIME
              attempted to set the time to a value less than the current value
              of the CLOCK_MONOTONIC clock.

And for settimeofday().

       EINVAL (settimeofday()): timezone is invalid.

       EINVAL (settimeofday()): tv.tv_sec is negative or tv.tv_usec is outside
              the range [0..999,999].

       EINVAL (since Linux 4.3)
              (settimeofday()): An attempt was made to set the time to a value
              less than the current value of the CLOCK_MONOTONIC clock (see
              clock_gettime(2)).

       EPERM  The calling process has insufficient privilege to call
              settimeofday(); under Linux the CAP_SYS_TIME capability is
              required.

But this is not a bug in GNU date.  This is likely the effect of
CLOCK_MONOTONIC in the Linux kernel.

       CLOCK_MONOTONIC
              Clock that cannot be set and represents monotonic time since--as
              described by POSIX--"some unspecified point in the past".  On
              Linux, that point corresponds to the number of seconds that the
              system has been running since it was booted.

              The CLOCK_MONOTONIC clock is not affected by discontinuous jumps
              in the system time (e.g., if the system administrator manually
              changes the clock), but is affected by the incremental
              adjustments performed by adjtime(3) and NTP.  This clock does
              not count time that the system is suspended.

I am not familiar with CLOCK_MONOTONIC but reading the documentation
points me to it as being the most likely reason this is not allowing
that time to be set.

I tested this in a victim system and if I was very quick I was able to
log in and set the time to :10 seconds but no earlier.

> I test with stime or settimeofday to set seconds 0, they are all have the problem.
> 1. I use buildroot-2013.05, the busybox is in 1.21.1, the linux kernel is in version 4.4.39.

That multiple frontends, GNU date and busybox date, all have the same
problem speaks that the problem is not with the frontend but with the
kernel handling the system call.

> 3.When set date command, the busybox uses function "stime" to set
> time, I use stime to set time around linux epoch time,
>    but the stime seems not work well.
>    int ret = 0;
>    time_t time = 20;
>    ret = stime(&time);
>    printf("ret %d %d\r\n",ret, errno);
>    perror("stime:");
> and the results are as follows:
>     ret -1 22
>     stime:: Invalid argument

And also confirmed by your independent test the the problem is not a
bug in GNU date.  Therefore I mark this GNU date bug ticket as closed
for our own accounting.  But please continue to discuss the issue
here.

Bob




Information forwarded to bug-coreutils@HIDDEN:
bug#40220; Package coreutils. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 25 Mar 2020 04:03:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Mar 25 00:03:00 2020
Received: from localhost ([127.0.0.1]:55847 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1jGxFp-0001Wg-7O
	for submit <at> debbugs.gnu.org; Wed, 25 Mar 2020 00:03:00 -0400
Received: from lists.gnu.org ([209.51.188.17]:46990)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail_hysong@HIDDEN>) id 1jGvGm-0006cR-67
 for submit <at> debbugs.gnu.org; Tue, 24 Mar 2020 21:55:50 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:36431)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <mail_hysong@HIDDEN>) id 1jGvGj-0006MS-Tp
 for bug-coreutils@HIDDEN; Tue, 24 Mar 2020 21:55:47 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: *
X-Spam-Status: No, score=1.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 HTML_MESSAGE,SPOOFED_FREEMAIL,XPRIO autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <mail_hysong@HIDDEN>) id 1jGvGf-0000FN-F6
 for bug-coreutils@HIDDEN; Tue, 24 Mar 2020 21:55:42 -0400
Received: from m13-30.163.com ([220.181.13.30]:17432)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <mail_hysong@HIDDEN>) id 1jGvGe-0008Mc-6w
 for bug-coreutils@HIDDEN; Tue, 24 Mar 2020 21:55:41 -0400
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=163.com;
 s=s110527; h=Date:From:Subject:MIME-Version:Message-ID; bh=os4pG
 D71X4EAG2ElVXkdPfZ5svb8bbihhWTHAdCo9Us=; b=qGVpiprpq9rmJRW2YL4A3
 zncvfdpYfcokobTjZLvt+wTeE8g5zwpEP5ZrW5HGoxuRxIkwN2O7bFgWpCfi6yKV
 CeAUvAmJBoqS/D90LLstNTic5VJ8ShgoliXvxtSPgjSK8pn3NEZiRJQCuJDMpxN8
 FCk+RX05PrQ7BVGyX/27gA=
Received: from mail_hysong$163.com ( [180.168.40.98] ) by
 ajax-webmail-wmsvr30 (Coremail) ; Wed, 25 Mar 2020 09:40:13 +0800 (CST)
X-Originating-IP: [180.168.40.98]
Date: Wed, 25 Mar 2020 09:40:13 +0800 (CST)
From: shy  <mail_hysong@HIDDEN>
To: bug-coreutils@HIDDEN
Subject: date command set linux epoch time failed
X-Priority: 3
X-Mailer: Coremail Webmail Server Version XT5.0.10 build 20190724(ac680a23)
 Copyright (c) 2002-2020 www.mailtech.cn 163com
X-CM-CTRLDATA: ChAO/mZvb3Rlcl9odG09MzE0MDo1Ng==
Content-Type: multipart/alternative; 
 boundary="----=_Part_28362_852654238.1585100413631"
MIME-Version: 1.0
Message-ID: <307be938.1da0.1710f58dac0.Coremail.mail_hysong@HIDDEN>
X-Coremail-Locale: zh_CN
X-CM-TRANSID: HsGowABHMOh9tnpe+eEIAA--.6332W
X-CM-SenderInfo: xpdlzspk1v00rj6rljoofrz/xtbBFRrwPlXlkHUAywACsd
X-Coremail-Antispam: 1U5529EdanIXcx71UUUUU7vcSsGvfC2KfnxnUU==
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 3.x [fuzzy]
X-Received-From: 220.181.13.30
X-Spam-Score: 1.2 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview:  Hi all: I use command date -s "1970-01-20 00:00:00" to set
 date, but it failed. there is error message "date: can't set date: Invalid
 argument". It's UTC time and no timezone. I test with stime or settimeofday
 to set seconds 0, they are all have the problem. 
 Content analysis details:   (1.2 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (mail_hysong[at]163.com)
 -0.7 RCVD_IN_DNSWL_LOW      RBL: Sender listed at https://www.dnswl.org/,
 low trust [209.51.188.17 listed in list.dnswl.org]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.9 SPF_FAIL               SPF: sender does not match SPF record (fail)
 [SPF failed: Please see http://www.openspf.org/Why?s=mfrom;
 id=mail_hysong%40163.com; ip=209.51.188.17; r=debbugs.gnu.org]
 0.0 HTML_MESSAGE           BODY: HTML included in message
 0.0 SPOOFED_FREEMAIL       No description available.
 1.0 XPRIO                  Has X-Priority header
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Wed, 25 Mar 2020 00:02:56 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.8 (/)

------=_Part_28362_852654238.1585100413631
Content-Type: text/plain; charset=GBK
Content-Transfer-Encoding: base64

SGkgYWxsOgoKCkkgdXNlIGNvbW1hbmQgICAgIGRhdGUgLXMgIjE5NzAtMDEtMjAgMDA6MDA6MDAi
IHRvIHNldCBkYXRlLCBidXQgaXQgZmFpbGVkLiAgdGhlcmUgaXMgZXJyb3IgbWVzc2FnZSAiZGF0
ZTogY2FuJ3Qgc2V0IGRhdGU6IEludmFsaWQgYXJndW1lbnQiLgogSXQncyBVVEMgdGltZSBhbmQg
bm8gdGltZXpvbmUuCgoKSSB0ZXN0IHdpdGggc3RpbWUgb3Igc2V0dGltZW9mZGF5IHRvIHNldCBz
ZWNvbmRzIDAsIHRoZXkgYXJlIGFsbCBoYXZlIHRoZSBwcm9ibGVtLgoKCjEuIEkgdXNlIGJ1aWxk
cm9vdC0yMDEzLjA1LCB0aGUgYnVzeWJveCBpcyBpbiAxLjIxLjEsIHRoZSBsaW51eCBrZXJuZWwg
aXMgaW4gdmVyc2lvbiA0LjQuMzkuCgoKIyBkYXRlIC1zICIxOTcwLTAxLTIwIDAwOjAwOjAwIgpU
dWUgSmFuIDIwIDAwOjAwOjAwIFVUQyAxOTcwCiMgZGF0ZSAtUgpUdWUsIDIwIEphbiAxOTcwIDAw
OjAwOjAzICswMDAwCiMgZGF0ZSAtcyAiMTk3MC0wMS0wMSAwMDowMDowMCIKZGF0ZTogY2FuJ3Qg
c2V0IGRhdGU6IEludmFsaWQgYXJndW1lbnQKVGh1IEphbiAgMSAwMDowMDowMCBVVEMgMTk3MAoK
CjIuIEkgdGVzdCBpbiB1YnVudHUgdmVyc2lvbiAxNC4wNC4xLgpzaHlAdWJ1bnR1Oi9ldGMkIHN1
ZG8gZGF0ZSAtcyAiMjAyMC0wMy0wMSAwMDowMDowMCIKU3VuIE1hciAgMSAwMDowMDowMCBVVEMg
MjAyMApzaHlAdWJ1bnR1Oi9ldGMkIGRhdGUgLVIKU3VuLCAwMSBNYXIgMjAyMCAwMDowMDowMyAr
MDAwMAoKc2h5QHVidW50dTovZXRjJCBzdWRvIGRhdGUgLXMgIjE5NzAtMDEtMDEgMDA6MDA6MDAi
CgpkYXRlOiBjYW5ub3Qgc2V0IGRhdGU6IEludmFsaWQgYXJndW1lbnQKClRodSBKYW4gIDEgMDA6
MDA6MDAgVVRDIDE5NzAKCnNoeUB1YnVudHU6L2V0YyQgdW5hbWUgLWEKCkxpbnV4IHVidW50dSA0
LjQuMC0xNDItZ2VuZXJpYyAjMTY4fjE0LjA0LjEtVWJ1bnR1IFNNUCBTYXQgSmFuIDE5IDExOjI2
OjI4IFVUQyAyMDE5IHg4Nl82NCB4ODZfNjQgeDg2XzY0IEdOVS9MaW51eAoKCgoKMy5XaGVuIHNl
dCBkYXRlIGNvbW1hbmQsIHRoZSBidXN5Ym94IHVzZXMgZnVuY3Rpb24gInN0aW1lIiB0byBzZXQg
dGltZSwgSSB1c2Ugc3RpbWUgdG8gc2V0IHRpbWUgYXJvdW5kICBsaW51eCBlcG9jaCB0aW1lLAoK
ICAgYnV0IHRoZSBzdGltZSBzZWVtcyBub3Qgd29yayB3ZWxsLgoKICAgaW50IHJldCA9IDA7Cgog
ICB0aW1lX3QgdGltZSA9IDIwOwoKICAgcmV0ID0gc3RpbWUoJnRpbWUpOwoKICAgcHJpbnRmKCJy
ZXQgJWQgJWRcclxuIixyZXQsIGVycm5vKTsKCiAgIHBlcnJvcigic3RpbWU6Iik7CgphbmQgdGhl
IHJlc3VsdHMgYXJlIGFzIGZvbGxvd3M6CgogICAgcmV0IC0xIDIyCgogICAgc3RpbWU6OiBJbnZh
bGlkIGFyZ3VtZW50CgoKCgpCZXN0IHJlZ2FyZHMhCgoKCgoKCgoKIA==
------=_Part_28362_852654238.1585100413631
Content-Type: text/html; charset=GBK
Content-Transfer-Encoding: base64
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------=_Part_28362_852654238.1585100413631--





Acknowledgement sent to shy <mail_hysong@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-coreutils@HIDDEN. Full text available.
Report forwarded to bug-coreutils@HIDDEN:
bug#40220; Package coreutils. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 30 Mar 2020 02:45:01 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.